local __FILE__=tostring(debugstack(1,2,0):match("(.*):1:")) -- MUST BE LINE 1
local _,_,_,toc=GetBuildInfo()
local pp=print
--[[
Name: ABH-Ldb.lua
Revision: $Rev: 193 $
Author: Alar of Daggerspine
Email: alar@aspide.it
Website: http://www.curse.com
SVN: $HeadUrl:$
License: GPL v2.1
--]]
local me, ns = ...
--[===[@debug@
print("Loading",__FILE__," inside ",me)
--@end-debug@]===]
if (LibDebug) then LibDebug() end
local function debug(...) 
--[===[@debug@
print(...)
--@end-debug@]===]
end
local print=_G.print
local notify=_G.print
local error=_G.error
local function dump() end
local function debugEnable() end
if (LibStub("AlarLoader-3.0",true)) then
	local rc=LibStub("AlarLoader-3.0"):GetPrintFunctions(me)
	print=rc.print
	--[===[@debug@
	debug=rc.debug
	dump=rc.dump
	--@end-debug@]===]
	notify=rc.notify
	error=rc.error
	debugEnable=rc.debugEnable
else
	debug("Missing AlarLoader-3.0")
end
debugEnable(false)
local abh=LibStub("AceAddon-3.0"):GetAddon(me)
local xformat=format
local function format(formato,...)
	return xformat(formato,tostringall(...))
end
function abh:Description()
end
local L=LibStub("AceLocale-3.0"):GetLocale(me,true)
local bs=LibStub("LibBattleScan")
local C=LibStub("AlarCrayon-3.0"):GetColorTable()
local abh=LibStub("AceAddon-3.0"):GetAddon(me)
--[[ Standard prologue end --]]
--[[ -----------------------------------------
LibDataBroker Stuff
--]]
if (not LibStub:GetLibrary("LibDataBroker-1.1",true)) then 
	--[===[@debug@
	print("Missing libdatabroker")
	--@end-debug@]===]
	return 
end
local dataobj=LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject(me, {
	type = "data source",
	label = me,
	text='No bg',
	icon = "Interface\\GossipFrame\\BattleMasterGossipIcon",
})	
function dataobj:OnTooltipShow()
	self:AddLine("People who healed you:",C:Orange())
	for who,amount in pairs(abh.healedyoufor) do
		self:AddLine(format("%s: %d",who,amount))
	end
--[===[@debug@
	self:AddLine("-------------------------------")
	self:AddLine("Status",C:Green())
	local abases,apoints,hbases,hpoints,tpoints,hflags,aflags=bs:GetStatus()
	self:AddLine("Alliance",C:Alliance())
	self:AddLine(format("Basi: %d",abases))
	self:AddLine(format("Points: %d/%d",abases,tpoints))
	self:AddLine(format("Flags: %d",aflags))
	self:AddLine("Horde",C:Horde())
	self:AddLine(format("Basi: %d",hbases))
	self:AddLine(format("Points: %d/%d",hbases,tpoints))
	self:AddLine(format("Flags: %d",hflags))
	local bs=LibStub("LibBattleScan")
	self:AddLine(format("bgid: %s",bs:GetCurrentBgID()))	
	self:AddLine(format("bgname: %s",bs:GetCurrentBgName()))
	self:AddLine("Discovered BG",C:Green())
	local nearestnode=bs:GetNearestNode()
	if (nearestnode) then
		self:AddLine(format("Nearest node: %s (%f)",nearestnode.name,nearestnode.distance))
	end
	for s,l in pairs(bs:GetBgNames()) do	
		self:AddLine(format("%s:%s",s,l))	
	end
	self:AddLine("-------------------------------")
--@end-debug@]===]
	self:AddLine("Right-Click to open gui",C.Green())

end

function dataobj:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
	GameTooltip:ClearLines()
	dataobj.OnTooltipShow(GameTooltip)

	GameTooltip:Show()
end

function dataobj:OnLeave()
	GameTooltip:Hide()
end	
function dataobj:OnClick(button)
	abh:Print("Clicked",button)
	if (button=="RightButton") then
		abh:Gui()
	else
		bs:ShowCache()
	end
end
function abh:Description(msg)
	dataobj.text=msg or ''
end
function abh:BATTLESCAN_STARTED_BG(event,bg,bgname)
	dataobj.text=bgname
end
function abh:BATTLESCAN_ENDED_BG(event)
	dataobj.text='No bg'
end
abh.dataobj=dataobj
abh:RegisterMessage("BATTLESCAN_STARTED_BG")
abh:RegisterMessage("BATTLESCAN_ENDED_BG")
--[[
Achievement_BG_AB_defendflags
--]]


		
		