local __FILE__=tostring(debugstack(1,2,0):match("(.*):1:")) -- MUST BE LINE 1
local MAJOR_VERSION = ("LibBattleScan.lua"):gsub(".lua","")
local MINOR_VERSION = tonumber(string.sub("$Revision: 13 $", 12, -3))
local _,_,_,toc=GetBuildInfo()
local _G=_G
local pp=print
--- **LibBattleScan** scans BG chats for events and raises messages accordingly
-- It is inspired by but absolutely not based on GloryLib.
-- In contrary to GloryLib, LibBattleScan try to work out events by checking the various information available instead of relying on a massive chat scan.
-- At the present time, only flag picking in WSG uses localized chat scan.
-- This library (when used embedded) needs (some libraries of) Ace3.
-- I didnt hard include them inside the embeddable folder (LibBattleScan) so
-- you should add these dependencies yourself
--
-- LibBattleScan uses:
--
--	**LibStub**
--
--	**CallbackHandler-1.0**
--
--	**AceLocale-3.0**
--
--	**AceTimer-3.0**
--
--	**AceEvent-3.0**
--
--	**AceBucket-3.0**
-- @usage
-- bs = Libstub("LibBattleScan")
-- bs:AllianceColor()
-- self:RegisterMessage("BATTLESCAN_SOMETHING")
-- @class file
-- @name LibBattleScan

--[[
Name: LibBattleScan.lua
Revision: $Rev: 13 $
Author: Alar of Daggerspine
Email: alar@aspide.it
Website: http://www.curse.com
SVN: $HeadUrl:$
License: GPL v2.1
--]]
local me, ns = ...
	--[===[@debug@
	print("Loading",__FILE__," inside ",me)
	--@end-debug@]===]
if (LibDebug) then LibDebug() end
local function debug(...) 
	--[===[@debug@
	print(...)
	--@end-debug@]===]
end
local print=_G.print
local notify=_G.print
local error=_G.error
local function dump() end
local function debugEnable() end
local L=LibStub("AceLocale-3.0"):GetLocale("LibBattleScan",true)
--[===[@debug@
if not L then L=LibStub("AceLocale-3.0"):NewLocale("LibBattleScan","enUS",true,true) end
L=LibStub("AceLocale-3.0"):GetLocale("LibBattleScan",true)
--@end-debug@]===]

if (LibStub("AlarLoader-3.0",true)) then
	local rc=LibStub("AlarLoader-3.0"):GetPrintFunctions(MAJOR_VERSION)
	print=rc.print
	--[===[@debug@
	debug=rc.debug
	dump=rc.dump
	--@end-debug@]===]
	notify=rc.notify
	error=rc.error
	debugEnable=rc.debugEnable
else
	debug("Missing AlarLoader-3.0")
end
debugEnable(true)
--[[ Standard prologue end --]]
if (LibDebug) then LibDebug() end
local C=LibStub("AlarCrayon-3.0"):GetColorTable()
local lib,old=LibStub:NewLibrary(MAJOR_VERSION,MINOR_VERSION)
if (not lib) then
	debug("Already loaded a newer or equal version of " .. MAJOR_VERSION)
	return -- Already loaded
end
if (old) then
	debug(format("Upgrading %s from %s to %s",MAJOR_VERSION,old,MINOR_VERSION))
end
--[===[@debug@
local stub=setmetatable({},{__index=function() return function() end end})
local function GetChatFrame(chat,mandatory)
	if (chat) then
		for i=1,10 do
			local frame=_G["ChatFrame" .. i]
			if (not frame) then break end
			if (frame.name==chat) then return frame end
		end
	end
	if mandatory then 
		return stub
	else
		return DEFAULT_CHAT_FRAME
	end
end
--@end-debug@]===]
_G.battlescanlog={}
local function logEvent(event,...)	
	GetChatFrame("Events",true):AddMessage(
		C('BS: ',"orange") ..
		C(event,"green") .. ' ' ..
		C(strjoin(' | ',tostringall(...)),"yellow"))
	tinsert(battlescanlog,date("%X") .. ' ' .. tostring(event) .. ' ' .. strjoin(' | ',tostringall(...)))
end
LibStub("AceTimer-3.0"):Embed(lib)
LibStub("AceEvent-3.0"):Embed(lib)
LibStub("AceBucket-3.0"):Embed(lib)
local events = {
	CHAT_MSG_BG_SYSTEM_ALLIANCE=0,
	CHAT_MSG_BG_SYSTEM_HORDE=0,
	CHAT_MSG_BG_SYSTEM_NEUTRAL=0,
	UPDATE_WORLD_STATES=0,
	CHAT_MSG_MONSTER_YELL=0,
	CHAT_MSG_RAID_BOSS_EMOTE=0
}
local unitevents={
	PLAYER_FOCUS_CHANGED=1,
	PLAYER_TARGET_CHANGED=1,
	UNIT_COMBAT=1,
	UNIT_TARGET=1,
	UNIT_HEALTH=1,
	UPDATE_MOUSEOVER_UNIT=1,
	UNIT_SPELLCAST_START=1,	
	RAID_ROSTER_UPDATE=0,
	UPDATE_BATTLEFIELD_SCORE=0,
	UPDATE_BATTLEFIELD_STATUS=0
}
local EventsRunning=false
local H=2
local A=1
local HFlagTaken=nil
local AFlagTaken=nil
local carrier=nil
local capture=nil
local tpoints=0
local hpoints=0
local apoints=0
local abases=0
local hbases=0
local aflags=0
local hflags=0
local myfaction
local mylocalizedfaction
local theirfaction
local theirlocalizedfaction
local zone=""
local oldzone="nomedizonachenonesiste"
local bg="NN"
local oldbg=""
local defending
local defender
local allyCarrier
local hordeCarrier
local empty={}
local Colors={
	Horde={1,0,0},
	Alliance={0,0.682,0.937}
}
_G.bscolor=Colors
local RESPATTERN="(%d+)%D*(%d+)/(%d+)"
local FLAGPATTERN="(%d+)/%d+"
local PICKPATTERN={
	H=strlower(L["the alliance flag was picked up by"]),
	A=strlower(L["the horde flag was picked up by"])
}
local DROPPATTERN={
	H=strlower(L["the alliance flag was dropped by"]),
	A=strlower(L["the horde flag was dropped by"])

}
local TIMEPATTERNS= {
	seconds=gsub(strlower(L["30 seconds"]),"30","(%%d%%d)"),
	minute=gsub(strlower(L["1 minute"]),"1","(%%d)")
}
local HordeCarrierBuffTexture="INV_BannerPVP_02"
local AllyCarrierBuffTexture="INV_BannerPVP_01"
local HordeCarrierBuff=nil
local AllyCarrierBuff=nil
local monitor

local new, del
do
	local list = setmetatable({}, {__mode="k"})
	function new()
		local t = next(list)
		if t then
			list[t] = nil
			return t
		else
			return {}
		end
	end
	function del(t)
		setmetatable(t, nil)
--[[
		for k in pairs(t) do
			t[k] = nil
		end
--]]
		list[t] = true
	end
end
local pk={
	name=1,
	killingBlows=2,
	honorKills=3,
	deaths=4,
	honorGained=5,
	faction=6,
	rank=7,
	race=8,
	class=9,
	englishclass=10,
	damageDone=11,
	healingDone=12,
	health=13,
	updated=14
}
local metavector={
	__index=function(table,key)
	table[key]={}
	return table[key]
	end
}
local pgcache={}
--[[
 H= Horde controlled
 A = Alliance controlled
 a = Alliance assaulted
 h = Horde assaulted
 space = neutral
 nil = not relevant
--]]
local _states={
	[1]=" HA", -- Mine
	[4]="a", -- Graveyard
	[9]="aHAh", -- Tower
	[13]="HhA", -- Graveyard
	[16]=" aAhH", -- Gold Mine
	[21]=" aAhH", -- Lumber Mill
	[26]=" aAhH", -- Blacksmith
	[31]=" aAhH", -- Farm
	[36]=" aAhH", -- Stables
	[65]="idDHdDAdD", -- WorkShop
	[102]="idD", -- Yellow Gate
	[105]="idD", -- Purple Gate
	[108]="idD", -- Green Gate
	[74]="idD", -- Neutral gate
	[77]="idD", -- Horde Gate
	[80]="idD", -- Ally Gate
	[135]=" AaHh", --Siege Workshop
	[140]=" AaHh", -- Hangar
	[145]=" AaHh", -- Docks
	[150]=" AaHh" -- Refinery
}
local states={}
for i,s in pairs(_states) do
	local l=s:len()
	for x=1,l do
		states[i+x-1]=s:sub(x,x)
	end
end
_states=nil
local shorts= {
	WarsongGulch='WSG',
	AlteracValley='AV',
	ArathiBasin='AB',
	NetherstormArena='EOS',
	IsleofConquest='IOC',
	StrandoftheAncients='SOA',
	LakeWintergrasp='WGR',
	TolBarad='TB',
	--BattleForGilneas='BFG',
	GilneasBattleground2='BFG',
	TwinPeaks='TP'
}
local laststatus={}

local nodenames=setmetatable({},metavector)
local longs={}
local almostzero=0.00000000000000000000001
local rates={
	BFG={
	[0]=almostzero, 
	10/9, 
	10/3, 
	30, 
	1600
	},
	AB={
		[0]=almostzero, 
		5/6, 
		10/9, 
		5/3, 
		10/3, 
		30, 
		1600
	},
	EOS={
		[0]=almostzero, -- 0
		1/2, -- 1
		2.5/2, -- 2
		5/2, -- 3
		10/2 --4
	}
}
setmetatable(rates,metavector)
local flags={
	EOS={
		[0]=almostzero,
        75, -- 0
        85, -- 1
        100, -- 2
        500, -- 3
	}
}
setmetatable(flags,metavector)
--[===[@debug@
lib.pgcache=pgcache
lib.flags=flags
lib.rates=rates
lib.nodenames=nodenames
lib.longs=longs
lib.shorts=shorts
lib.events=events
lib.states=states
--@end-debug@]===]

function lib:GetRates(bg)
	return rates[bg]
end
function lib:GetFlags(bg)
	return flags[bg]
end
function lib:Cache()
	return pgcache
end
function lib:IterateCache()
	return pairs(pgcache)
end
function lib:PurgeCache()
	for i,v in pairs(pgcache) do pgcache[i]=nil end
end

function lib:UPDATE_BATTLEFIELD_SCORE(...)
--[===[@debug@
	logEvent(...)
--@end-debug@]===]
	for i = 1,GetNumBattlefieldScores() do
		self:Push(GetBattlefieldScore(i))
	end
end
function lib:RAID_ROSTER_UPDATE(...)
--[===[@debug@
	logEvent(...)
--@end-debug@]===]
	RequestBattlefieldScoreData()
end
function lib:ScanBuff(unit,buff)
	for i=1,99 do
		local name,rank,texture=UnitBuff("player",i)
		if (texture) then
			if (texture:match(buff)) then
				return name
			end
		else
			break
		end
	end
end

function lib:EventsOn()
	RequestBattlefieldScoreData()
	if (EventsRunning) then return end
	if (not myfaction) then 
		myfaction,mylocalizedfaction=UnitFactionGroup("player")
		if (myfaction=="Alliance") then
			theirfaction="Horde"
			theirlocalizedfaction=FACTION_HORDE
		else	
			theirfaction="Alliance"
			theirlocalizedfaction=FACTION_ALLIANCE
		end
	end

	for event,_ in pairs(events) do
		local faction=event:match('CHAT_MSG_BG_SYSTEM_(%a+)')
		self:RegisterEvent(event,"EventHandler",faction)
	end
	for event,bucket in pairs(unitevents) do
		if bucket==0 then
			self:RegisterEvent(event)
		else
			self:RegisterBucketEvent(event,bucket)
		end
	end
	self.carriertimer=self:ScheduleRepeatingTimer("UpdateStatus",1)
	EventsRunning=true

end
--- Returns english enemy faction name (i.e. Alliance or Horde)
-- @param none
-- @usage print(bs:EnemyFaction())
function lib:EnemyFaction()
	return theirfaction
end
--- Returns english enemy faction name (i.e. Alliance or Horde)
-- @param none
-- @usage print(bs:FriendFaction())
function lib:FriendFaction()
	return myfaction
end
--- Returns r,g,b for friendly faction color
-- @param none
-- @usage frame:SetTextColor(bs:FriendFactionColor())
function lib:FriendFactionColor()
	if (myfaction=="Alliance") then
		return self:AllianceColor()
	else
		return self:HordeColor()
	end
end
--- Returns r,g,b for enemy faction color
-- @param none
-- @usage frame:SetTextColor(bs:EnemyFactionColor())
function lib:EnemyFactionColor()
	if (myfaction=="Horde") then
		return self:HordeColor()
	else
		return self:AllianceColor()
	end
end
--- Returns r,g,b for alliance color
-- @param none
-- @usage frame:SetTextColor(bs:AllianceColor())
function lib:AllianceColor()
	return unpack(Colors.Alliance)
end
--- Returns r,g,b for horde color
-- @param none
-- @usage frame:SetTextColor(bs:HordeColor())
function lib:HordeColor()
	return unpack(Colors.Horde)
end
--- nodeinfo structure
-- @name nodeinfo
-- @class table
-- @field realdistance number  //in 0 to 1 range with a lot of decimals :)
-- @field distance  number  //floor(realdistance * 10000)
-- @field name string  //select(1,GetMapLandmarkInfo(i))
-- @field description string  //select(2,GetMapLandmarkInfo(i))
-- @field icon number //select(3,GetMapLandmarkInfo(i))
--


--- Returns a nodeinfo object for the nearest map node
-- @param none
-- @usage Mostly for internal use
-- @see nodeinfo
function lib:GetNearestNode()
	local px,py = GetPlayerMapPosition('player')
	local mindistance=99999
	local nodeinfo={realdistance=math.huge}
	for i=1,GetNumMapLandmarks() do
		local name,description,icon,nx,ny=GetMapLandmarkInfo(i)
	 	local x=nx - px
	 	local y=ny -py
	 	local d=x*x + y* y
	 	local rc,distance=pcall(math.sqrt,d)
    	if ( rc and distance <= nodeinfo.realdistance) then 
    		nodeinfo.name=name
    		nodeinfo.description=description
    		nodeinfo.icon=icon
    		nodeinfo.realdistance=distance
    		nodeinfo.distance=floor(distance * 10000)
    	end
    end
    if nodeinfo.realdistance < math.huge then return nodeinfo else return nil end
end		
function lib:EventsOff()
	for event,_ in pairs(events) do
		self:UnregisterEvent(event)
	end
	for event,bucket in pairs(unitevents) do
		if bucket==0 then
			self:UnregisterEvent(event)
		end
	end
	self:UnregisterAllBuckets()
	self:CancelTimer(self.carriertimer,true)
	self:SendMessage("BATTLESCAN_ENDED_BG")
	EventsRunning=false
end
--- True if you have the Honorable Defender buff (untested)
-- @param none
-- @return boolean
-- @usage if (bs:isDefending() then dosomething() end
function lib:isDefending()
	return defending
end
--- True if the textureindex represent a conflcited node
-- @param icon number texture index from select(3,GetMapLandmarkInfo(i))
-- @usage if bs:isInConflict(bs:NodeToIcon(1)) then dosomething() end
-- @see lib:NodeToIcon
function lib:isInConflict(icon)
	local s=states[icon] or ''
	return s:match('[ah]'),s
end
--- True if the icon index represent an horde assaulted node
-- @param icon number texture index from select(3,GetMapLandmarkInfo(i))
-- @usage if bs:isHordeAssaulted(bs:NodeToIcon(1)) then dosomething() end
-- @see lib:NodeToIcon
function lib:isHordeAssaulted(icon)
	local s=states[icon] or ''
	return s=='h'
end
--- Converts an index to the actual texture used
-- @param number Indicates which landmark to query (from 1 to GetNumMapLandmarks())
-- @return number textureIndex
function lib:NodeToIcon(index)
	return select(3,GetMapLandmarkInfo(index))
end
--- True if the icon index represent a node controlled from the requested faction
-- @param icon number texture index from select(3,GetMapLandmarkInfo(i))
-- @param string faction english name (Alliance or Horde)
-- @usage if bs:isControlled(bs:NodeToIcon(1),'Horde') then dosomething() end
-- @see lib:NodeToIcon

function lib:isControlled(icon,faction)
	if faction=="Horde" then
		return self:isHordeControlled(icon)
	else
		return self:isAllianceControlled(icon)
	end
end
--- True if the icon index represent a node cassaulted from the requested faction
-- @param icon number texture index from select(3,GetMapLandmarkInfo(i))
-- @param string faction english name (Alliance or Horde)
-- @usage if bs:isAssaulted(bs:NodeToIcon(1),'Alliance') then dosomething() end
-- @see lib:NodeToIcon
function lib:isAssaulted(icon,faction)
	if faction=="Horde" then
		return self:isHordeAssaulted(icon)
	else
		return self:isAllianceAssaulted(icon)
	end
end
--- True if the icon index represent an alliance assaulted node
-- @param icon number texture index from select(3,GetMapLandmarkInfo(i))
-- @usage if bs:isAllianceAssaulted(bs:NodeToIcon(1)) then dosomething() end
-- @see lib:NodeToIcon
function lib:isAllianceAssaulted(icon)
	local s=states[icon] or ''
	return s=='a'
end
--- True if the icon index represent an alliance controlled node
-- @param icon number texture index from select(3,GetMapLandmarkInfo(i))
-- @usage if bs:isAllianceControlled(bs:NodeToIcon(1)) then dosomething() end
-- @see lib:NodeToIcon
function lib:isAllianceControlled(icon)
	return states[icon]=="A"
end
--- True if the icon index represent an horde controlled node
-- @param icon number texture index from select(3,GetMapLandmarkInfo(i))
-- @usage if bs:isHordeControlled(bs:NodeToIcon(1)) then dosomething() end
-- @see lib:NodeToIcon
function lib:isHordeControlled(icon)
	return states[icon]=="H"
end
--- True if the icon index represent a destroyed node
-- @param icon number texture index from select(3,GetMapLandmarkInfo(i))
-- @usage if bs:isDestroyed(bs:NodeToIcon(1)) then dosomething() end
-- @see lib:NodeToIcon

function lib:isDestroyed(icon)
	local s=states[icon] or ''
	return s:match('[dD]'),s
end
function lib:HordeUI()
	return H
end
function lib:AllianceUI()
	return A
end
function lib:Defender()
	local wasdefending
	if (not defender) then
		for i=1,99 do
			local name,rank,texture=UnitBuff("player",i)
			if not name then break end
			if texture:match("Achievement_BG_AB_defendflags") then
				if (not defending) then
					print("You are defending",name,GetZoneText(),GetRealZoneText())
				end
				defending=true
				defender=name
				break
			end
			defending=false
		end
	else
		defending=UnitBuff("player",defender)
	end
	if (defending ~=wasdefending) then
		self:Fire("DEFENDER",defending )
	end
	return defending
end
function lib:CheckFlag()
	local oldhflags=hflags
	local oldaflags=aflags
	local captured
	self:UpdateStatus(true)
	if (hflags > oldhflags) then
		self:Fire("HORDE_CAPTURED_FLAG",hflags)
		captured=true
	end
	if (aflags > oldaflags) then
		self:Fire("ALLIANCE_CAPTURED_FLAG",hflags)
		captured=true
	end
	if aflags>=3 then self:Fire("ALLIANCE_WON") return end
	if hflags>=3 then self:Fire("HORDE_WON") return end 
	if captured then self:Fire("CAPTURED_FLAG") end
end
function lib:UpdateStatus(alldata)
	local H=H + ((bg=="WSG" or bg=="EOS") and 1 or 0)
	local A=A + ((bg=="WSG" or bg=="EOS") and 1 or 0)
	local _,hstate,_,htext,_, _, _,_,_,_,_,_ = GetWorldStateUIInfo(H)	
	AFlagTaken=hstate==2
	htext=htext or ""
	local hb,hp,max1=htext:match(RESPATTERN)
	local hf=htext:match(FLAGPATTERN)
	local _,astate,atext,_, _, _,_,_,_,_,_ = GetWorldStateUIInfo(A)	
	HFlagTaken=astate==2
	atext=atext or ""
	local ab,ap,max2=atext:match(RESPATTERN)
	local af=atext:match(FLAGPATTERN)
	apoints=tonumber(ap) or 0
	hpoints=tonumber(hp) or 0
	tpoints=tonumber(max1) or 0
	abases=tonumber(ab) or 0
	hbases=tonumber(hb) or 0
	if (alldata) then
		aflags=tonumber(af) or 0
		hflags=tonumber(hf) or 0
	end
end
function lib:GetStatus()
	self:UpdateStatus()
--[===[@debug@	
	if (floor(GetTime()) % 30 == 0) then
		print("GetStatus",abases,apoints,hbases,hpoints,tpoints,hflags,aflags)
	end	
--@end-debug@]===]	
	return abases or 0,apoints or 0,hbases or 0,hpoints or 0,tpoints or 0,hflags or 0,aflags or 0
end
--- Return defined ids
-- The table returrned is like {WarsongGulch="WSG"}
-- @return table
-- @usage for _,id in pairs(bs:GetShorts() do print(id) end
function lib:GetShorts()
	return shorts
end
function lib:ResetStatus()
	abases,apoints,hbases,hpoints,tpoints,hflags,aflags=0,0,0,0,0,0,0
end

function lib:GetNodeIndexFromMessage(message)
	message=strlower(message)
	local l=GetNumMapLandmarks()
	for i = 1,l do
		if not nodenames[bg][i] then
			nodenames[bg][i]=strlower(GetMapLandmarkInfo(i))
			if (bg=="AV" and i == 2) then
				nodenames[bg][i]="abcdefghijklmneopgnonesistequestonome"
			end
		end
		debug(message,nodenames[bg][i])
		if message:find(nodenames[bg][i]) then
			laststatus[i]=select(3,GetMapLandmarkInfo(i))
			return i
		end
	end
	for i=1,l do
		local actualstatus=select(3,GetMapLandmarkInfo(i))
		if actualstatus~=laststatus[i] then
			laststatus[i]=actualstatus
			return i 
		end
	end
	return nil
end
function lib:doResources(message)
if not message then return end
	debug("Called doResources on",message)
	local node=self:GetNodeIndexFromMessage(message)
	if (node) then
		self:Fire("NODE_CHANGED",node,nodenames[bg][node])
	end
end	

function lib:doCarrierScan(actor,faction,message)
--[[
ally event:
	Horde; x picked up, AFlagTaken=true
--]]
	if (actor and (faction=="ALLIANCE" or faction=="HORDE")) then
		local oldaflags,oldhflags=aflags,hflags
		local oldataken,oldhtaken=AFlagTaken,HFlagTaken
		local actorfaction=strupper(self:UnitFaction(actor))
		local actorisenemy=(actorfaction~=faction)
		self:UpdateStatus(true)
		-- Check for a change in flags. 
		if (aflags > oldaflags) then
			-- Alliance captured flag, reset carriers
			self:VoidACarrier()
			self:VoidHCarrier()
			debug("Alliance captured flag")
			self:Fire("ALLIANCE_CAPTURED_FLAG")
			return -- notihing left to do
		end
		if (hflags > oldhflags) then
			-- Horde captured flag, reset carriers
			self:VoidACarrier()
			self:VoidHCarrier()
			debug("Horde captured flag")
			self:Fire("HORDE_CAPTURED_FLAG")
			return -- notihing left to do
		end
		local winner = GetBattlefieldWinner()
		if (winner) then
			if (winner==0) then
				self:Fire("HORDE_WON")
			else
				self:Fire("ALLIANCE_WON")
			end
			return
		end
		if not HFlagTaken then self:VoidACarrier() end
		if not AFlagTaken then self:VoidHCarrier() end
		local text=strlower(message)
		if text:match(PICKPATTERN.H) then
			debug("HPICK")
			self:LoadHCarrier(actor)
			return
		end
		if text:match(PICKPATTERN.A) then
			debug("APICK")
			self:LoadACarrier(actor)
			return
		end
		if text:match(DROPPATTERN.H) then
			debug("HDROP")
			self:VoidHCarrier()
			return
		end	
		if text:match(DROPPATTERN.A) then
			debug("ADROP")
			self:VoidACarrier()
			return
		end	
		-- No match info, falling back to euristic
		debug(faction,actorisenemy)
		if (faction=="ALLIANCE") then
--[[  3 possible messages
		The Horde flag was picked up by Belbashi!
		Belbashi captured the Horde flag!
		The Alliance Flag was dropped by Casperz!
--]]
			if (actorisenemy) then
				self:VoidHCarrier() --The Alliance Flag was dropped by Casperz!
				debug("Horde dropped flag")
			elseif (HFlagTaken and not oldhtaken) then
				debug("Alliance took flag")
				self:LoadACarrier(actor)
			else
				debug("Alliance returned flag")
				self:VoidHCarrier(actor)
			end
		else
			if (actorisenemy) then
				debug("Alliance dropped flag")
				self:VoidACarrier() --The Alliance Flag was dropped by Casperz!
			elseif (AFlagTaken and not oldataken) then
				debug("Horde took flag")
				self:LoadHCarrier(actor)
			else 
				debug("Horde returned flag")
				self:VoidACarrier()
			end		
		end
	end
end
function lib:doCheckTimer(message)
	local text=strlower(message or "")
	local n=text:match(TIMEPATTERNS.seconds)
	if tonumber(n) then
		self:Fire("STARTS_IN_SECONDS",n)
		return
	end
	n=text:match(TIMEPATTERNS.minute) 
	if tonumber(n)then
		self:Fire("STARTS_IN_SECONDS",60)
		return
	end
end
function lib:EventHandler(faction,event,message,p1,p2,p3,actor,...)
--[===[@debug@
	logEvent(event,message,p1,p2,p3,actor,...)
--@end-debug@]===]
	if (faction and faction ~= "NEUTRAL") then debug(' ') debug("---->",event,message,'(',actor,')') end
	if (event=="UPDATE_WORLD_STATES" and bg=="WSG" ) then
		self:CheckFlag()
		return
	end
	if (bg =="WSG" or bg =="TP") and FACTION ~="NEUTRAL" then 	
		self:doCarrierScan(actor,faction,message)
	end
	if (bg=="BFG" or bg =="AV" or bg =="AB" or bg=="IOC") and FACTION ~="NEUTRAL" then
		self:doResources(message)
	end
	if (faction=="NEUTRAL") then
		self:doCheckTimer(message)
	end
	if (faction or event=="CHAT_MSG_MONSTER_YELL") then
		self:Fire("CHAT_MESSAGE",strupper(faction or "NEUTRAL"),message)
	end

end
function lib:VoidACarrier()
	allyCarrier=nil
	self:Fire("ALLIANCE_CARRIER")
end
function lib:VoidHCarrier()
	hordeCarrier=nil
	self:Fire("HORDE_CARRIER")
end
function lib:LoadACarrier(actor)
	local pg=pgcache[actor] or empty
	allyCarrier=pg.name or actor
	self:Fire("ALLIANCE_CARRIER",actor,pg.name or actor,pg.race or 'unknown',pg.class or 'unknown',pg.health or 100)
end
function lib:LoadHCarrier(actor)
	local pg=pgcache[actor] or empty
	hordeCarrier=pg.name or actor
	self:Fire("HORDE_CARRIER",actor,pg.name or actor,pg.race or 'unknown',pg.class or 'unknown',pg.health or 100)
end
function lib:UnitFaction(name)
	local data=pgcache[name] 
	if data then return data['faction'] end
	return theirfaction
end

--- True if the player is in a world pvparea and battle is started
-- 
-- @param none

function lib:isWorldPvp()
	local nome=GetRealZoneText()
	for i = 1,GetNumWorldPVPAreas() do
		local pvpID,localname,isActive=GetWorldPVPAreaInfo(i)
		if localname==nome and isActive then return true end
	end
	return false
	 
end

--- True if the player is inside a battlegrounds.
-- In witergrasp return true ONLY if battleground is started
-- @param none

function lib:isInBattlegrounds()
	return select(2,IsInInstance()) == "pvp" or (GetZonePVPInfo() == "combat" and self:isWorldPvp())
end
--- Return the bg id (WSG,AB, etc) from the map file name
-- @param zone string GetMapInfo()
-- @usage print(bs:GetIdFromMapZone(GetMapInfo())
function lib:GetIdFromMapZone(zone)
	return shorts[zone] or 'NN'
end
--- Return the english upper case class from the internal cache
-- @param name string a player name (with or without realm)
-- @return string
function lib:GetClass(name)
	if (pgcache[name]) then
		return pgcache[name]['class'] or "NONE"
	end
	return "NONE"
end
--- Return the localized class from the internal cache
-- @param name string a player name (with or without realm)
-- @return string
function lib:GetLocalizedClass(name)
	if (pgcache[name]) then
		return pgcache[name]['localizedclass'] or "NONE"
	end
	return L["none"]
end
--- Return the wholecache data for the requested player
-- @param name string a player name (with or without realm)
-- @return list name,faction,race,class,localizedclass,healt,lastupdated
function lib:GetInfo(name)
	local p=pgcache[name]
	if (not p) then return '','','','',0,0 end
	return p.name,p.faction,p.race,p.class,p.localizedclass,p.health,p.updated
end
--- Return health from the internal cache
-- @param name string a player name (with or without realm)
-- @return string
function lib:GetHealth(name)
	if (pgcache[name]) then
		return pgcache[name]['health'] or 100
	end
	return 0
end
--- Return race from the internal cache
-- @param name string a player name (with or without realm)
-- @return string
function lib:GetRace(name)
	if (pgcache[name]) then
		return pgcache[name]['race'] or 100
	end
	return L["unknown"]
end
--- Return localized battleground name
-- @param zone string GetMapInfo()
-- @usage print(bs:GetNameFromMapZone(GetMapInfo())

function lib:GetNameFromMapZone(zone)
	return longs[self:GetIdFromMapZone(zone)]
end
--- Return localized battleground name
-- @param id string "WSG","AB" ...
-- @usage print(bs:GetNameFromMapZone(GetMapInfo())
function lib:GetNameFromID(id)
	return longs[id]
end

function lib:Fire(event,...)
--[===[@debug@
	debugEnable(true)
	debug("fired BATTLESCAN",event,...)
--@end-debug@]===]
	self:SendMessage("BATTLESCAN_" .. event,...)
end
function lib:PLAYER_ENTERING_WORLD(...)
--[===[@debug@
	logEvent(...)
--@end-debug@]===]
	myfaction,mylocalizedfaction=UnitFactionGroup("player")
	if (myfaction=="Alliance") then
		theirfaction="Horde"
		theirlocalizedfaction=FACTION_HORDE
	else	
		theirfaction="Alliance"
		theirlocalizedfaction=FACTION_ALLIANCE
	end
	self:ScheduleTimer("ZONE_CHANGED_NEW_AREA",5,"FAKE_ZONE_CHANGED_NEW_AREA")
	local acolor=ChatTypeInfo["BG_SYSTEM_ALLIANCE"]
	local hcolor=ChatTypeInfo["BG_SYSTEM_HORDE"]
	Colors.Horde={hcolor.r,hcolor.g,hcolor.b}
	Colors.Alliance={acolor.r,acolor.g,acolor.b}
	
end
local function trueHealth(unit)
	local h=UnitHealth(unit)
	local hm=UnitHealthMax(unit)
	if (hm >0 and h>0) then
		h=floor(h/hm*100)
	end
	return tonumber(h) or 0
end
function lib:Push(name,	killingBlows,honorKills,deaths,honorGained,faction,race,class,englishclass,damageDone,healingDone,health,updated)
	if (not pgcache[name]) then
		pgcache[name]=new()
		pgcache[name]['name']=name
		pgcache[name]['race']=race
		pgcache[name]['class']=englishclass
		pgcache[name]['localizedclass']=class
		if faction==1 then
			pgcache[name]['faction']="Alliance"
		else
			pgcache[name]['faction']="Horde"
		end
	end
	pgcache[name:match("^[^-]+")]=pgcache[name]	
end
function lib:UNIT_HEALTH(units)
	for unit,n in pairs(units) do 
		self:ScanUnit(unit)
		self:ScanUnit(unit .."target")
	end
end
function lib:UNIT_SPELLCAST_START(units)
	for unit,n in pairs(units) do 
		self:ScanUnit(unit .."target")
	end
end
function lib:UNIT_COMBAT(units)
	for unit,n in pairs(units) do 
		self:ScanUnit(unit)
	end
end
function lib:UNIT_TARGET(units)
	for unit,n in pairs(units) do 
		self:ScanUnit(unit .. "target")
	end
end
function lib:UPDATE_MOUSEOVER_UNIT()
	self:ScanUnit("mouseover")
	self:ScanUnit("mouseovertarget")
end
function lib:PLAYER_TARGET_CHANGED()
	self:ScanUnit("target")
end
function lib:PLAYER_FOCUS_CHANGED()
	self:ScanUnit("focus")
end
function lib:UPDATE_BATTLEFIELD_STATUS(...)
--[===[@debug@
	print(self:isInBattlegrounds(),...)
--@end-debug@]===]
end
function lib:ScanUnit(unit)
	if not unit then return end
	if (unit~="player") then 
		local name,realm=UnitName(unit)
		if (name) then 
			if (realm) then
				name=name ..'-'.. realm
			end
			if (not pgcache[name]) then
				RequestBattlefieldScoreData()
			else
				local h=trueHealth(unit)
				if (h > 0 ) then
					if bg=="WSGXXX" then
						local got=false
						if not AllyCarrierBuff then
							AllyCarrierBuff=self:ScanBuff(unit,AllyCarrierBuffTexture)
							got=AllyCarrierBuff
						else
						 	got=UnitBuff(unit,AllyCarrierBuff)
						end
						if got then
							if name ~= allyCarrier then
								allyCarrier=name
								lib:Fire("ALLIANCE_CARRIER",name)
							end
						else
							if not HordeCarrierBuff then
								HordeCarrierBuff=self:ScanBuff(unit,HordeCarrierBuffTexture)
								got=HordeCarrierBuff
							else
						 		got=UnitBuff(unit,HordeCarrierBuff)
						 	end
						 	if got then
								if (name ~= hordeCarrier) then
									hordeCarrier=name
									lib:Fire("HORDE_CARRIER",name)
								end
							end
						end
					end
					pgcache[name].health=h
					pgcache[name].updated=floor(GetTime())
					if (name==allyCarrier) then lib:Fire("ALLIANCE_CARRIER_HEALTH",name,h,GetTime()) end
					if (name==hordeCarrier) then lib:Fire("HORDE_CARRIER_HEALTH",name,h,GetTime()) end
				end
			end
		end
	end
end
function lib:ZONE_CHANGED_NEW_AREA(...)
--[===[@debug@
	print("ZC",...)
	print(GetRealZoneText())
--@end-debug@]===]
	local zone=GetMapInfo()
	debug("I am in",zone, "was",oldzone)
	if (zone ~= oldzone) then
		self:CheckZone(zone)
	else
		self:ScheduleTimer("CheckZone",3) -- Recheck after a while, if zone has not been updated
	end	
end
function lib:CheckZone(zone)
	if (not zone) then
		zone=GetMapInfo()
	end
	if (zone ~= oldzone) then
		debug('Moved to',zone,'from',oldzone,'(',GetRealZoneText(),'-',GetZoneText(),')')
		debug(bg,',',oldbg,',',self:isInBattlegrounds())
		if (not self:isInBattlegrounds()) then
			self:EventsOff()
			self:Fire("LEFT_BATTLEGROUND",oldbg,longs[oldbg])
			bg="NN"
		else
			SetMapToCurrentZone()
			bg=self:GetIdFromMapZone(zone)
			if (oldbg~=bg) then
				self:EventsOff()
				self:Fire("LEFT_BATTLEGROUND",oldbg,longs[oldbg])
			end
			if (bg~="NN") then
				longs[bg]=GetRealZoneText()
--[===[@debug@
				print("isbg",zone,bg,longs[bg],GetRealZoneText())
--@end-debug@]===]				
				self:ResetStatus()
				self:UpdateStatus(true)
				if (oldbg~=bg or not EventsRunning) then
					wipe(laststatus)
					self:Fire("ENTERED_BATTLEGROUND",bg,longs[bg])
				end
			end
		end
		oldbg=bg
		oldzone=zone
	end
	return 
end
function lib:ClearCache()
	for i,v in pairs(pgcache) do
		pgcache[i]=del(v)
	end
end
--- Get current battleground ID
-- @return string
function lib:GetCurrentBgID()
	return bg
end
--- Get current battleground Name
-- @return string
function lib:GetCurrentBgName()
	return longs[bg]
end
--- Get long names of all supported battlegrounfs
-- @return table
function lib:GetBgNames()
	return longs
end
function lib:Refresh()
	oldzone="nomedizonachenonesiste"
	self:ZoneCheck()
end
function lib:ShowCache()
	--[===[@debug@
	local gui=LibStub("AceGUI-3.0",true)
	if (not gui) then 
		print("Missing AceGUI")
		return
	end
	monitor=gui:Create("BsMonitor")
	monitor:SetCallback("OnClose",function(self) self:Release() end)
	for n,d in kpairs(pgcache) do
		monitor:Add(n,d)
	end
	monitor:Show()
	--@end-debug@]===]
end
function lib:LoadedFrom()
	return __FILE__
end

--[[
Achievement_BG_AB_defendflags
--]]
-- This event drives the whole thing
lib:RegisterEvent("ZONE_CHANGED_NEW_AREA")
lib:RegisterEvent("PLAYER_ENTERING_WORLD")
local popup=StaticPopupDialogs["CONFIRM_BATTLEFIELD_ENTRY"]
do
	local oldshow=popup.OnShow
	popup.OnShow=function(self,data) oldshow(self,data) LibStub("LibBattleScan"):Fire("BATTLEGROUND_POPUP",data) end 
end
--lib:ScheduleTimer("ZONE_CHANGED",5)

		
		
